// sdl_timer.hh - SDL timer implementation
//
// Copyright (C) 2000 Trevor Spiteri
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef SDL_TIMER_HH
#define SDL_TIMER_HH

#include "SDL.h"

#include "timer.hh"

namespace sdl {

    // Implementation of Timer::timer
    class timer : public Timer::timer {
    public:
        timer(int msec = 1000);

        void set_delay(int msec);
        int get_delay();
        void start();
        void stop();
        void wait();
        void done();
        int ticks();
    private:
        void update();     // update state of timer for other functions
        Uint32 last_time;  // stores time of last update
        bool running;      // whether timer is running or not
        int delay;         // delay between ticks in ms
        int Ticks;         // number of pending ticks
    };

} // namespace sdl

#endif // !SDL_TIMER_HH
